﻿var legendHighlightClass = "hotspot-highlight";
var svgHightlightClass = "highlight";

$("[data-insert-svg]").each(function( index ) {
	var hotspotId = $(this).attr("data-hotspot-id");
	$(this).after(omd.svgImages[$(this).attr("data-insert-svg")]);
	var svg = $(this).next();
	svg.attr('data-hotspot-id', hotspotId);
    $(this).remove();
});

$("svg").each(function( index ) {
    var svg = Snap(this);

    $(this).on("mouseenter click", "[hotspotid]", function() {
		var allLegentexts = $(this).closest("picture").find(".legendtext");
		allLegentexts.addClass("hidden");
		showDiv(findPlaceholderDiv($(this)));
		leaveFocus(findAllSvgElements(svg));
		setFocus(findMatchingSvgElements($(this), svg));
        showDiv(findLegendDiv($(this)));
		hideDiv(findPlaceholderDiv($(this)));
    });
});

function findMatchingSvgElements(domElement, svg) {
    var ref = domElement.attr("hotspotid");
    return svg.selectAll("*[hotspotid=\"" + ref + "\"]");
}

function findAllSvgElements(svg) {
    return svg.selectAll("*[hotspotid]");
}

function findLegendDiv(domElement) {
    var ref = domElement.attr("hotspotid");
    var entry = $(domElement).closest("picture").find(".legendtext#" + ref);
	
    return entry.first();
}
	
function findPlaceholderDiv(domElement) {
    var ref = domElement.attr("hotspotid");
    var entry = $(domElement).closest("picture").find(".placeholder");

    return entry.first();
}

function setFocus(svgElements) {
  if(!svgElements)
    return;
  svgElements.forEach(function(element) {
    element.addClass(svgHightlightClass);
  });
}

function leaveFocus(svgElements) {
  if(!svgElements)
    return;
  svgElements.forEach(function(element) {
    element.removeClass(svgHightlightClass);
  });
}

function showDiv(div) {
  if(!div.length)
    return;
	div.removeClass("hidden");
}

function hideDiv(div) {
  if(!div.length)
    return;
  div.addClass("hidden");
}
